import React from 'react';
import { closeEditor, updateCellValue } from '../../actionCreators';
import defaultOptions from '../../defaultOptions';
import { getDateInputValue } from '../../Utils/DateUtils';
var CellEditorDate = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, rowKeyValue = _a.rowKeyValue, value = _a.value, autoFocus = _a.autoFocus;
    var inputValue = value && getDateInputValue(value);
    return (React.createElement("input", { autoFocus: autoFocus, className: defaultOptions.css.dateInput, type: 'date', value: inputValue || '', onChange: function (event) {
            var targetValue = event.currentTarget.value;
            var newValue = targetValue ? new Date(targetValue) : null;
            dispatch(updateCellValue(rowKeyValue, column.key, newValue));
        }, onBlur: function () {
            dispatch(closeEditor(rowKeyValue, column.key));
        } }));
};
export default CellEditorDate;