import * as React from 'react';
import { updateSortDirection } from '../../actionCreators';
import defaultOptions from '../../defaultOptions';
import { SortDirection } from '../../enums';
import { isSortingEnabled } from '../../Utils/SortUtils';
var HeadCellContent = function (props) {
    var column = props.column, dispatch = props.dispatch, sortingMode = props.sortingMode;
    var sortingEnabled = isSortingEnabled(sortingMode);
    var sortClick = sortingEnabled ? function () {
        dispatch(updateSortDirection(column.key));
    } : undefined;
    return (React.createElement("div", { className: defaultOptions.css.theadCellContent + " " + (sortingEnabled ? 'ka-pointer' : ''), onClick: sortClick },
        React.createElement("span", null, column.title),
        column.sortDirection && sortingEnabled && (React.createElement("span", { className: column.sortDirection === SortDirection.Ascend
                ? defaultOptions.css.iconSortArrowUp
                : defaultOptions.css.iconSortArrowDown }))));
};
export default HeadCellContent;