import * as React from 'react';
import { updatePageIndex } from '../../actionCreators';
import { centerLength, getPagesForCenter } from '../../Utils/PagingUtils';
var PageIndex = function (_a) {
    var dispatch = _a.dispatch, activePageIndex = _a.activePageIndex, pageIndex = _a.pageIndex;
    return (React.createElement("div", { onClick: function () { return dispatch(updatePageIndex(pageIndex)); }, className: "ka-paging-page-index " + (activePageIndex === pageIndex ? 'ka-paging-page-index-active' : '') }, pageIndex + 1));
};
var Paging = function (_a) {
    var enabled = _a.enabled, pagesCount = _a.pagesCount, _b = _a.pageIndex, pageIndex = _b === void 0 ? 1 : _b, dispatch = _a.dispatch;
    var pages = new Array(pagesCount).fill(undefined).map(function (_, index) { return index; });
    var isEndShown = pageIndex < pages.length - centerLength && pages.length > centerLength + Math.ceil(centerLength / 2);
    var isStartShown = pageIndex >= centerLength && pages.length > centerLength + Math.ceil(centerLength / 2);
    var centerPages = getPagesForCenter(pages, isStartShown, isEndShown, pageIndex);
    if (enabled) {
        return (React.createElement("div", { className: 'ka-paging' },
            React.createElement("div", { className: 'ka-paging-pages' },
                isStartShown &&
                    (React.createElement(React.Fragment, null,
                        React.createElement(PageIndex, { dispatch: dispatch, pageIndex: 0, activePageIndex: pageIndex }),
                        React.createElement("div", { className: "ka-paging-page-index", key: -1 }, "..."))),
                centerPages.map(function (value, index) {
                    return (React.createElement(PageIndex, { dispatch: dispatch, pageIndex: value, activePageIndex: pageIndex, key: value }));
                }),
                isEndShown &&
                    (React.createElement(React.Fragment, null,
                        React.createElement("div", { className: "ka-paging-page-index", key: -2 }, "..."),
                        React.createElement(PageIndex, { dispatch: dispatch, pageIndex: pages[pages.length - 1], activePageIndex: pageIndex }))))));
    }
    return (React.createElement(React.Fragment, null));
};
export default Paging;