var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { ActionType } from '../../enums';
import { getVirtualized } from '../../Utils/Virtualize';
import Rows from '../Rows/Rows';
var VirtualizedRows = function (props) {
    var data = props.data, dispatch = props.dispatch, virtualScrolling = props.virtualScrolling;
    var onFirstRowRendered = function (firstRowRef) {
        if (firstRowRef
            && firstRowRef.current
            && (virtualScrolling
                && (!virtualScrolling.itemHeight
                    || !virtualScrolling.tbodyHeight))) {
            var itemHeight = firstRowRef.current.offsetHeight || 40;
            var tbodyHeight = (firstRowRef.current.parentElement && firstRowRef.current.parentElement.offsetHeight)
                || 600;
            var newVirtualScrolling = __assign({ itemHeight: itemHeight,
                tbodyHeight: tbodyHeight }, virtualScrolling);
            dispatch({ type: ActionType.UpdateVirtualScrolling, virtualScrolling: newVirtualScrolling });
        }
    };
    var virtualizedData = data;
    var virtualized;
    if (virtualScrolling) {
        virtualized = getVirtualized(virtualScrolling, virtualizedData);
        virtualizedData = virtualized.virtualizedData;
    }
    return (React.createElement(React.Fragment, null,
        virtualized && React.createElement("tr", { style: { height: virtualized.beginHeight } },
            React.createElement("td", { style: { height: virtualized.beginHeight } })),
        React.createElement(Rows, __assign({}, props, { data: virtualizedData, onFirstRowRendered: onFirstRowRendered })),
        virtualized && (React.createElement("tr", { style: { height: virtualized.endHeight } },
            React.createElement("td", { style: { height: virtualized.endHeight } })))));
};
export default VirtualizedRows;