import { isNumber } from 'util';
export var HeadCellResizeStateAction = 'HeadCellResizeStateAction';
export var getMouseMove = function (currentWidth, minWidth, startX, dispatch) { return function (event) {
    var newWidth = event.screenX - startX;
    if (newWidth !== currentWidth) {
        newWidth = getValidatedWidth(newWidth, minWidth);
        dispatch({ type: HeadCellResizeStateAction, width: newWidth });
    }
}; };
export var getValidatedWidth = function (newWidth, minWidth) {
    if (newWidth < minWidth) {
        return minWidth;
    }
    return newWidth;
};
export var getMinWidth = function (style) {
    var minWidth = 20;
    var styleMinWidth = style && style.minWidth;
    if (styleMinWidth && isNumber(styleMinWidth)) {
        minWidth = styleMinWidth;
    }
    return minWidth;
};
export var headCellDispatchWrapper = function (setWidth, dispatch) { return function (action) {
    if (action.type === HeadCellResizeStateAction) {
        setWidth(action.width);
    }
    else {
        dispatch(action);
    }
}; };