import { updateCellValue } from '../actionCreators';
import { ActionType } from '../enums';
import { getCopyOfArrayAndAddItem } from './ArrayUtils';
export var isEditableCell = function (editingMode, column, rowEditableCells) {
    if (column.isEditable !== undefined) {
        return column.isEditable;
    }
    return !!rowEditableCells.find(function (c) { return c.columnKey === column.key; });
};
export var getEditableCell = function (column, rowEditableCells) {
    if (column.isEditable === false) {
        return undefined;
    }
    return rowEditableCells.find(function (c) { return c.columnKey === column.key; });
};
export var addItemToEditableCells = function (item, editableCells) {
    return getCopyOfArrayAndAddItem(item, editableCells);
};
export var getCellEditorDispatchHandler = function (dispatch) {
    return function (action) {
        if (action.type === ActionType.UpdateEditorValue) {
            dispatch(updateCellValue(action.rowKeyValue, action.columnKey, action.value));
        }
        else {
            dispatch(action);
        }
    };
};
export var removeItemFromEditableCells = function (item, editableCells) {
    return editableCells.filter(function (c) { return c.columnKey !== item.columnKey || c.rowKeyValue !== item.rowKeyValue; });
};