export var centerLength = 5;
var DEFAULT_PAGE_SIZE = 10;
export var getPagesCount = function (data, paging) {
    if (!paging || !paging.enabled) {
        return 1;
    }
    if (paging.pagesCount) {
        return paging.pagesCount;
    }
    return Math.ceil(data.length / ((paging && paging.pageSize) || DEFAULT_PAGE_SIZE));
};
export var getPageData = function (data, paging) {
    if (!paging || !paging.enabled || paging.pagesCount) {
        return data;
    }
    var pageSize = paging.pageSize || DEFAULT_PAGE_SIZE;
    var pageIndex = paging.pageIndex || 0;
    var startIndex = pageSize * pageIndex;
    return data.slice(startIndex, startIndex + pageSize);
};
export var getPagesForCenter = function (pages, isStartShown, isEndShown, pageIndex) {
    if (isStartShown && !isEndShown) {
        return pages.filter(function (page) { return (page >= pages.length - centerLength - 1); });
    }
    else if (!isStartShown && isEndShown) {
        return pages.filter(function (page) { return (page <= centerLength); });
    }
    else if (isStartShown && isEndShown) {
        return pages.filter(function (page) { return (page >= pageIndex - Math.floor(centerLength / 2)) && (page <= pageIndex + Math.floor(centerLength / 2)); });
    }
    return pages;
};